
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o list list.c

#include <stdio.h>
#include <stdlib.h>
#include <glib.h>

int main(void)
{
GList *number_list = NULL, *iter;
GList *revnumber_list = NULL;
int x=2, y=1, z=4, a=30;
int i, fireoff;

//add numbers to the list
for (i = 0; i < 10; i++) {
number_list = g_list_prepend (number_list, GINT_TO_POINTER (i));
}

// Print data
printf("\nPRINT LIST DATA:\n");
iter=number_list;
while (iter) {
printf("data is %d\n", GPOINTER_TO_INT(iter->data));
iter = iter->next;
}
putchar('\n');  

// /////////////
// UTILITIES
// /////////////

//Gets the position of the element containing the given data (starting from 0).
printf("Index of the element containing the given data:\n");
for (i = 0; i < 10; i++) {
printf("Index # '%i' is: '%d'\n", i, g_list_index(number_list, GINT_TO_POINTER (i)));
}

// Count number of elements
printf("\nTotal number of elements is %d\n", g_list_length(number_list));
//putchar('\n');

// get data from specific locations
printf("\nThe first item is '%d'\n", g_list_first(number_list)->data);
printf("The last item is '%d'\n", g_list_last(number_list)->data);
printf("The third item is '%d\n\n", g_list_nth_data(number_list, 3));  

// Get the element at poistion number
printf("First element is \"%d\"\n", g_list_nth_data(number_list, 0));
printf("Second element is \"%d\"\n", g_list_nth_data(number_list, 1));
putchar('\n');

// ///////////////
printf("--------------------\n");

// //////////
// Tests to verify list is still working
// //////////
/* 
* This works, but it's a bad idea. It messes with the list data pointer 
* 'i' doesn't know how to move thru the list...
*  only g_list_next knows how to do that.
for (i = 0; i < 10; i++) {
printf("The # '%i' item is '%d'\n", i, number_list->data);
number_list = g_list_next(number_list); //this moves the list
}
*/
// Better to just use nth_data for printing the list
printf("PRINT LIST DATA, again:\n");  
for (i = 0; i < 10; i++) {
printf("The # '%i' item is '%d'\n", i, g_list_nth_data(number_list, i));
}

revnumber_list = g_list_reverse(number_list);

printf("\nPRINT reverse LIST DATA:\n");  
for (i = 0; i < 10; i++) {
printf("The # '%i' item is '%d'\n", i, g_list_nth_data(revnumber_list, i));
}


// looping to access the data in the list
tryagain:
printf( "\n Enter a num > 0 '('ex. 1') to continue, or 0 to end. \n\n");
scanf("%d", &fireoff);
if (fireoff > 0) {  
printf( "\n Success. \n\n");  


printf("PRINT LIST DATA, again:\n");  
for (i = 0; i < 10; i++) {
printf("The # '%i' item is '%d'\n", i, g_list_nth_data(number_list, i));
}


printf( "\n Success. \n\n");  

printf("\nPRINT reverse LIST DATA:\n");  
for (i = 0; i < 10; i++) {
printf("The # '%i' item is '%d'\n", i, g_list_nth_data(revnumber_list, i));
}


goto tryagain;
}  //if fireoff number > 0, run again     
else { 

//free memory
g_list_free(number_list);
g_list_free(revnumber_list);
return 0;
}
}


//jhearon, 2016
