
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o gslist gslist.c

#include <stdio.h>
#include <glib.h>

int main(int argc, char** argv) {

int mynum;
//or
//gint mynum;	
const gchar * glib_check_version ();
GSList *number_list = NULL;

number_list = g_slist_append (number_list, GINT_TO_POINTER (1));
number_list = g_slist_append (number_list, GINT_TO_POINTER (2));
number_list = g_slist_append (number_list, GINT_TO_POINTER (3));
number_list = g_slist_append (number_list, GINT_TO_POINTER (2));

printf("Items in the list: \n\n");

while (number_list != NULL)
{
//Use GINT_TO_POINTER to store integers as pointers (above), 
//and then use GPOINTER_TO_INT (below) to get the integer back. 	
printf("List data: %d\n", number_list->data);
//or
mynum = GPOINTER_TO_INT(number_list->data);
printf("mynumber: %d\n", mynum);

number_list = g_slist_next(number_list);
}

//free memory
g_slist_free(number_list);
return 0;
}

//jhearon, 2016
