
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o mynary mynary.c


#include <stdio.h>
#include <glib.h>

gboolean iter(GNode* n, gpointer data) { 
	gint mydata = GPOINTER_TO_INT(data);
printf(" %d [ %d ],", GPOINTER_TO_INT(n->data), mydata);
if (mydata == GPOINTER_TO_INT(n->data))
{
	printf("\n mydata [%d] matched \n", mydata);
	return TRUE;
}
else {
return FALSE;
}
}

void foreach(GNode *n, gpointer data){
	printf("%d ", GPOINTER_TO_INT(n->data));
}

                                         
int main(int argc, char** argv) 
{

gint j;
gint k = 3;
gpointer mydata, mynum;

//Creates a new GNode containing the given data. Used to create the first node in a tree.
GNode* root = g_node_new(GINT_TO_POINTER( 1 ));

for (j = 2; j < 14; j++) {
//Inserts a GNode as the last child of the given parent.
 g_node_append_data(root, GINT_TO_POINTER(j));
k++;
}

//assign '6' to mydata
mydata = GINT_TO_POINTER(6);
printf("\n mydata = %d\n", GPOINTER_TO_INT(mydata));

//printing using the interator func(above)
//looking for a match for the number '6'
printf(">Some numbers to start with\n");
g_node_traverse(root, G_PRE_ORDER, G_TRAVERSE_ALL, -1, iter, mydata);
 
 //print info on the tree and children
printf("\n\n printing info on the tree and children...\n");
printf("The number of nodes in the tree is: %d\n", g_node_n_nodes(root, G_TRAVERSE_ALL));
printf("The number of children is: %d\n", g_node_n_children (root));
printf("The depth of the GNode is: %d\n", g_node_depth (root));
printf("\nThe Root node's data is: %d\n", GPOINTER_TO_INT(g_node_get_root(root)->data));

//printing child nodes only
printf("\nprinting children only\n"); 
  if (root->children)
    {
      GNode *child;
      child = root->children;
      
      while (child)
	{
	  GNode *current;
	  
	  current = child;
	  child = current->next;
	  
	  mynum = current->data;
      printf(" %d ", GPOINTER_TO_INT(mynum));

	}
  }

//Removes root and its children from the tree, freeing any memory allocated.
g_node_destroy(root);


return 0;
}


/* REFERENCES
*  
*  https://github.com/MarkTseng/mySampleCode/tree/master/anage-C-Data-Using-the-GLib-Collections-example
*  https://sourcecodebrowser.com/glib2.0/2.27.0/gnode_8c.html#aa1f8f4f0a2d6eb0029a40f62fd12a57c
*  https://searchcode.com/codesearch/view/7283799/
*/

//jhearon, 2016


