
//gcc -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -lglib-2.0 -o slices slices.c

/* Shows simple use of GLib's memory management
 * called 'slices'.
 */

#include <glib.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>

int main (void)
{
gint *mem[5];
//or use char
//gchar *mem[5];
gint i = 0;
gint j;
gint k = 2;

//one block contains 12 slices
mem[i] = g_slice_alloc (12);

// Fill in the memory with inst nums
for (j = 0; j < 12; j++) {
//mem[i][j] = i * j;
mem[i][j] = k;
k++;
printf(" %d | ",  mem[i][j] );
}
printf("\n ");

//free the block
g_slice_free1 (12, mem[i]);
}

/* REFERENCES
*  
* //https://developer.gnome.org/glib/stable/glib-Memory-Slices.html
*/

//jhearon, 2016
